
package eu.dnetlib.dhp.schema.oaf;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;
import java.util.Objects;
import java.util.Optional;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * The type Oaf.
 */
public abstract class Oaf implements Serializable {

	/**
	 * The list of datasource id/name pairs providing this relationship.
	 */
	protected List<KeyValue> collectedfrom;

	private DataInfo dataInfo;

	private Long lastupdatetimestamp;

	/**
	 * Gets collectedfrom.
	 *
	 * @return the collectedfrom
	 */
	public List<KeyValue> getCollectedfrom() {
		return collectedfrom;
	}

	/**
	 * Sets collectedfrom.
	 *
	 * @param collectedfrom the collectedfrom
	 */
	public void setCollectedfrom(List<KeyValue> collectedfrom) {
		this.collectedfrom = collectedfrom;
	}

	/**
	 * Gets data info.
	 *
	 * @return the data info
	 */
	public DataInfo getDataInfo() {
		return dataInfo;
	}

	/**
	 * Sets data info.
	 *
	 * @param dataInfo the data info
	 */
	public void setDataInfo(DataInfo dataInfo) {
		this.dataInfo = dataInfo;
	}

	/**
	 * Gets lastupdatetimestamp.
	 *
	 * @return the lastupdatetimestamp
	 */
	public Long getLastupdatetimestamp() {
		return lastupdatetimestamp;
	}

	/**
	 * Sets lastupdatetimestamp.
	 *
	 * @param lastupdatetimestamp the lastupdatetimestamp
	 */
	public void setLastupdatetimestamp(Long lastupdatetimestamp) {
		this.lastupdatetimestamp = lastupdatetimestamp;
	}

	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (o == null || getClass() != o.getClass())
			return false;
		Oaf oaf = (Oaf) o;
		return Objects.equals(getDataInfo(), oaf.getDataInfo())
			&& Objects.equals(lastupdatetimestamp, oaf.lastupdatetimestamp);
	}

	@Override
	public int hashCode() {
		return Objects.hash(dataInfo, lastupdatetimestamp);
	}
}
