
package eu.dnetlib.dhp.schema.oaf;

import java.io.Serializable;
import java.util.*;
import java.util.stream.Collectors;

/**
 * The type Oaf entity.
 */
public abstract class OafEntity extends Oaf implements Serializable {

	private String id;

	private List<String> originalId;

	private List<StructuredProperty> pid;

	private String dateofcollection;

	private String dateoftransformation;

	private List<ExtraInfo> extraInfo;

	private OAIProvenance oaiprovenance;

	/**
	 * Gets id.
	 *
	 * @return the id
	 */
	public String getId() {
		return id;
	}

	/**
	 * Sets id.
	 *
	 * @param id the id
	 */
	public void setId(String id) {
		this.id = id;
	}

	/**
	 * Gets original id.
	 *
	 * @return the original id
	 */
	public List<String> getOriginalId() {
		return originalId;
	}

	/**
	 * Sets original id.
	 *
	 * @param originalId the original id
	 */
	public void setOriginalId(List<String> originalId) {
		this.originalId = originalId;
	}

	/**
	 * Gets pid.
	 *
	 * @return the pid
	 */
	public List<StructuredProperty> getPid() {
		return pid;
	}

	/**
	 * Sets pid.
	 *
	 * @param pid the pid
	 */
	public void setPid(List<StructuredProperty> pid) {
		this.pid = pid;
	}

	/**
	 * Gets dateofcollection.
	 *
	 * @return the dateofcollection
	 */
	public String getDateofcollection() {
		return dateofcollection;
	}

	/**
	 * Sets dateofcollection.
	 *
	 * @param dateofcollection the dateofcollection
	 */
	public void setDateofcollection(String dateofcollection) {
		this.dateofcollection = dateofcollection;
	}

	/**
	 * Gets dateoftransformation.
	 *
	 * @return the dateoftransformation
	 */
	public String getDateoftransformation() {
		return dateoftransformation;
	}

	/**
	 * Sets dateoftransformation.
	 *
	 * @param dateoftransformation the dateoftransformation
	 */
	public void setDateoftransformation(String dateoftransformation) {
		this.dateoftransformation = dateoftransformation;
	}

	/**
	 * Gets extra info.
	 *
	 * @return the extra info
	 */
	public List<ExtraInfo> getExtraInfo() {
		return extraInfo;
	}

	/**
	 * Sets extra info.
	 *
	 * @param extraInfo the extra info
	 */
	public void setExtraInfo(List<ExtraInfo> extraInfo) {
		this.extraInfo = extraInfo;
	}

	/**
	 * Gets oaiprovenance.
	 *
	 * @return the oaiprovenance
	 */
	public OAIProvenance getOaiprovenance() {
		return oaiprovenance;
	}

	/**
	 * Sets oaiprovenance.
	 *
	 * @param oaiprovenance the oaiprovenance
	 */
	public void setOaiprovenance(OAIProvenance oaiprovenance) {
		this.oaiprovenance = oaiprovenance;
	}

	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (o == null || getClass() != o.getClass())
			return false;
		if (!super.equals(o))
			return false;
		OafEntity oafEntity = (OafEntity) o;
		return Objects.equals(id, oafEntity.id);
	}

	@Override
	public int hashCode() {
		return Objects.hash(super.hashCode(), id);
	}
}
